package eu.chorevolution.vsb.playgrounds.clientserver.testdpws;

import org.ws4d.java.JMEDSFramework;
import org.ws4d.java.client.DefaultClient;
import org.ws4d.java.client.SearchManager;
import org.ws4d.java.communication.CommunicationException;
import org.ws4d.java.communication.DPWSCommunicationManager;
import org.ws4d.java.communication.DPWSProtocolVersion;
import org.ws4d.java.configuration.DPWSProperties;
import org.ws4d.java.security.CredentialInfo;
import org.ws4d.java.service.Device;
import org.ws4d.java.service.InvocationException;
import org.ws4d.java.service.Operation;
import org.ws4d.java.service.parameter.ParameterValue;
import org.ws4d.java.service.parameter.ParameterValueManagement;
import org.ws4d.java.service.reference.DeviceReference;
import org.ws4d.java.service.reference.ServiceReference;
import org.ws4d.java.types.SearchParameter;

import eu.chorevolution.vsb.playgrounds.clientserver.dpws.DocuExampleDevice;

import org.ws4d.java.types.LocalizedString;
import org.ws4d.java.types.QName;
import org.ws4d.java.types.QNameSet;

public class DocuExampleSearchClient extends DefaultClient {
	
	final static String	namespace	= DocuExampleDevice.DOCU_NAMESPACE;
	static QName deviceQname = new QName("DocuExampleDevice", namespace);
	static QName serviceQname = new QName("BasicServices", namespace);
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		JMEDSFramework.start(args);
		DPWSProperties.getInstance().removeSupportedDPWSVersion(DPWSProtocolVersion.DPWS_VERSION_NOT_SET);
		
		DocuExampleSearchClient client = new DocuExampleSearchClient();
		
		SearchParameter searchParameter = new SearchParameter();
		searchParameter.setDeviceTypes(new QNameSet(deviceQname), DPWSCommunicationManager.COMMUNICATION_MANAGER_ID);
		SearchManager.searchDevice(searchParameter, client, null);
		
		System.err.println("Begin search services");
		// search services
		searchParameter = new SearchParameter();
		searchParameter.setServiceTypes(new QNameSet(serviceQname), DPWSCommunicationManager.COMMUNICATION_MANAGER_ID);
		SearchManager.searchService(searchParameter, client, null);
		System.err.println("End search services");
		
	}
	
	public void serviceFound(ServiceReference serviceRef, SearchParameter searchParameter, String comManId){
		
		System.err.println(" serviceFound ");
		
		try {
			
			
			System.err.println("=== Start requesting Operation DocuExampleSimpleOperation =======");
			Operation op = serviceRef.getService().getOperation(serviceQname, "DocuExampleSimpleOperation", null, null);
			ParameterValue request = op.createInputValue();
			ParameterValueManagement.setString(request, "name", "toto");
			
			System.err.println(" Send request : name=toto");
			ParameterValue result = op.invoke(request, CredentialInfo.EMPTY_CREDENTIAL_INFO);
			
			String reply = ParameterValueManagement.getString(result, "repy");
			System.err.println(" Get response : repy="+reply);
			System.err.println("=== End requesting Operation DocuExampleSimpleOperation =======");
			
			
		} catch (CommunicationException | InvocationException e) {e.printStackTrace();}
		
	}

	public void deviceFound(DeviceReference devRef, SearchParameter searchParameter, String comManId) {
		
			
			Device device;
			try {
				
				device = devRef.getDevice();
				System.err.println("Found DocuExampleDevice: " + device.getFriendlyName(LocalizedString.LANGUAGE_EN));
				
			} catch (CommunicationException e) {e.printStackTrace();}
			
	}
	
	
	

}
