package eu.chorevolution.vsb.playgrounds.clientserver.testdpws;

import java.io.IOException;

import org.ws4d.java.JMEDSFramework;
import org.ws4d.java.security.CredentialInfo;
import org.ws4d.java.service.InvocationException;
import org.ws4d.java.service.Operation;
import org.ws4d.java.service.parameter.ParameterValue;
import org.ws4d.java.types.QName;

import eu.chorevolution.vsb.playgrounds.clientserver.dpws.DocuExampleDevice;
import eu.chorevolution.vsb.playgrounds.clientserver.dpws.DocuExampleService;
public class DocuExampleServiceProvider {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		JMEDSFramework.start( args );
		
		DocuExampleService service = new DocuExampleService();
		service.addOperation(new Operation("DocuHelloWorldOp", new QName("BasicServices", DocuExampleDevice.DOCU_NAMESPACE)) {

			// we have to implement the invoke method
			public ParameterValue invokeImpl(ParameterValue pv, CredentialInfo localCredentialInfo) throws InvocationException {
				// all we want to do is to print Hello World!
				System.err.println("HelloWorld!");
				return pv;
			}
		});
		
		DocuExampleDevice device = new DocuExampleDevice();
		device.addService(service);
		try{
			
			device.start();
			
		} catch (IOException e) {e.printStackTrace();}
		
	}

}
